function [mvu,h,a,ox,oy]=sunsim(num)
% code by jph

c=180/pi;
adc=-2.43/4096;

switch num
case 1
  data=load('pair1.csv');
  data(:,7:end)=[];
  a=0.02;
  h=2.5;
  mvu=0;
  
  data(:,3:end)=data(:,3:end)*adc; % conversion to [V]
  
case 2
  data=load('pair1.csv');
  data(:,3:6)=[];
  a=-0.01;
  h=1.086;
  mvu=0;
  
  data(:,3:end)=data(:,3:end)*adc; % conversion to [V]
  
case 3
  data=load('pair2.csv');
  data(:,7:end)=[];
  a=0.00;
  h=2.58;
  mvu=0.0013;
  
  data(:,3:end)=data(:,3:end)*adc; % conversion to [V]
  
case 4
  data=load('pair2.csv');
  data(:,3:6)=[];
  a=0.00;
  h=1.13;
  mvu=0.002;
  
  data(:,3:end)=data(:,3:end)*adc; % conversion to [V]
  
case 5
  data=load('slow32000.csv');
  data(:,7:end)=[];
  a=-1.3/c;
  h=1.35;
  mvu=2.02;
  
  data(:,3:end)=data(:,2+[4 2 1 3]); % permute channels
  
case 6
  data=load('slow32000.csv');
  data(:,3:6)=[];
  a=-1.7/c;
  h=1.71;
  mvu=2.02;
  
  data(:,3:end)=data(:,2+[1 3 4 2]); % permute channels

case 7
  data=load('new_32_4003.csv');
  data(:,7:end)=[];
  a=0/c;
  h=1.180;
  mvu=1.998;
  
  data(:,3:end)=data(:,2+[2 4 3 1]); % permute channels

case 8
  data=load('new_32_4003.csv');
  data(:,3:6)=[];
  a=4/c;
  h=2.7;
  mvu=2.021;
  
  data(:,3:end)=data(:,2+[2 4 3 1]); % permute channels
  
case 9
  data=load('new2_32_4006.csv');
  data(:,7:end)=[];
  a=0/c;
  h=1.180;
  mvu=1.998;
  
  data(:,3:end)=data(:,2+[2 4 3 1]); % permute channels

case 10
  data=load('new2_32_4006.csv');
  data(:,3:6)=[];
  a=4/c;
  h=1.460;
  mvu=1.998;
  
  data(:,3:end)=data(:,2+[2 4 3 1]); % permute channels

end

data(:,3:end)=mvu-data(:,3:end);

%disp(min(data(:,3:end)))

alp=data(:,1)/c; % inner
bet=data(:,2)/c; % outer

X1=data(:,3);
X2=data(:,4);
Y1=data(:,5);
Y2=data(:,6);

x=( (X2+Y1) - (X1+Y2) ) ./ ( (X1+X2) + (Y1+Y2) );
y=( (X2+Y2) - (X1+Y1) ) ./ ( (X1+X2) + (Y1+Y2) );

rot=[
 cos(a) sin(a)
-sin(a) cos(a)
];

for c1=1:numel(x)
  pn=rot*[x(c1);y(c1)];
  x(c1)=pn(1);
  y(c1)=pn(2);
end

sz=sqrt([numel(X1) numel(X1)]);

X1=reshape(X1,sz);
X2=reshape(X2,sz);
Y1=reshape(Y1,sz);
Y2=reshape(Y2,sz);

alp=reshape(alp,sz);
bet=reshape(bet,sz);

Omx=[
 0  0  0
 0  0 -1
 0  1  0
];

Omy=[
 0  0  1
 0  0  0
-1  0  0
];

x=reshape(x,sz);
y=reshape(y,sz);

ox=interp2(alp,bet,x,0,0);
x=x-ox;

oy=interp2(alp,bet,y,0,0);
y=y-oy;

mar=zeros(sz);
man=zeros(sz);

Vec=cell(0,1);
Res=cell(0,1);
for c1=1:numel(x)
  vec=[x(c1) y(c1) h]';
  vec=vec/norm(vec);
  Vec{end+1,1}=vec;
  switch 1 % method of rotation
  case 0 % symmetric
    res=expm(-Omx*bet(c1)+Omy*alp(c1))*[0 0 1]';
  case 1 % first rotate by outer (bet), then rotate by inner (alp)
    res=expm(Omy*alp(c1))*expm(-Omx*bet(c1))*[0 0 1]';
  end
  Res{end+1,1}=res;
  
  mar(c1)=vangle(vec,res);
  man(c1)=vangle(res,[0 0 1]');
end

cut=23/c;
fnd=find( abs(alp)<cut & abs(bet)<cut );
%sum(mar(fnd))

figure(1)

subplot(1,2,1)
mesh(alp,bet,x)
view(0,0)
axis tight
subplot(1,2,2)
mesh(alp,bet,y)
axis tight
view(-90,0)

% ---

figure(2)

subplot(1,2,1)
for c1=1:length(Vec)
  vec=Vec{c1};
  plot3(vec(1),vec(2),vec(3),'r+') % r+
  hold on
  res=Res{c1};
  plot3(res(1),res(2),res(3),'bo')
end
title('+ measured    o gnd truth')
hold off
axis equal

subplot(1,2,2)
mesh(alp*c,bet*c,mar*c)
hold on
[ccn,hcn]=contour(alp*c,bet*c,man*c); clabel(ccn,hcn);
hold off
title('error [deg]')
axis tight

% ---

figure(3)

subplot(2,2,1)
mesh(alp*c,bet*c,X1)
fig3label('X1')

subplot(2,2,2)
mesh(alp*c,bet*c,X2)
fig3label('X2')

subplot(2,2,3)
mesh(alp*c,bet*c,Y1)
fig3label('Y1')

subplot(2,2,4)
mesh(alp*c,bet*c,Y2)
fig3label('Y2')

% ---

cmp=find(3>=mar*c);
tot=X1+X2+Y1+Y2;

figure(4)

plot(mar(fnd)*c,tot(fnd)/max(tot(:)),'*r'); hold on % +r
plot(mar(cmp)*c,tot(cmp)/max(tot(:)),'*b'); hold off
xlabel('error [deg]')
ylabel('X1 + X2 + Y1 + Y2 [arbitraty scale]')
axis tight

% ---

figure(5)

subplot(1,3,1)

opa=0.7;
hnd=mesh(alp*c,bet*c,X1); alpha(opa)
set(hnd,'CData',X1*0+0.0)
hold on
hnd=mesh(alp*c,bet*c,X2); alpha(opa)
set(hnd,'CData',X1*0+0.333)
hnd=mesh(alp*c,bet*c,Y1); alpha(opa)
set(hnd,'CData',X1*0+0.666)
hnd=mesh(alp*c,bet*c,Y2); alpha(opa)
set(hnd,'CData',X1*0+1)
hold off

fig3label('channels X1, X2, Y1, Y2')

subplot(1,3,2)

surfl(alp*c,bet*c,x)
alpha(0.6)
hold on
surfl(alp*c,bet*c,y)
alpha(0.6)
hold off
axis tight
xlabel('inner [deg]')
ylabel('outer [deg]')
title('x and y of direction vector')
view(-45,8)

subplot(1,3,3)

[ccn,hcn]=contour(alp*c,bet*c,mar*c,[0.1 0.25 0.5 0.75 1 1.5 2 2.5]);
clabel(ccn,hcn);

xlabel('inner [deg]')
ylabel('outer [deg]')
title('pointing error [deg]')
axis equal
axis tight

set(5,'Position',[142 708 965 270])

for c1=1:5
  set(c1,'Color',[1 1 1])
end

function ang=vangle(v1,v2)
ang= acos(sum(v1.*v2) / (norm(v1)*norm(v2)));

function fig3label(tit)
axis tight
xlabel('inner [deg]')
ylabel('outer [deg]')
zlabel('channel [V]')
title(tit)
